#include <simple_audio.h>
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char** argv) {

  // Definiamo lo strumento sine che crea una semplice
  // onda sinusoidale
  sa_instrument sine;
  sine.fs = (sa_fourier_series*) malloc(sizeof(sa_fourier_series));
  sine.fs->cos_len = 0;
  sine.fs->sin_len = 1;
  sine.fs->sin_values = malloc(sizeof(double));
  sine.fs->sin_values[0] = 1.0;
  sine.fs->a_0 = 0;

  // Questo non assomiglia per nulla ad un organo, ma questo
  // genere di tentativi ci piace. 
  sa_instrument organ;
  int j;
  organ.fs = (sa_fourier_series*) malloc(sizeof(sa_fourier_series));
  organ.fs->cos_len = 0;
  organ.fs->sin_len = 100;
  organ.fs->sin_values = malloc(sizeof(double) * 100);
  organ.fs->a_0 = 0;
  for(j = 0; j < 100; j++) {
    if(j % 2 == 1)
      organ.fs->sin_values[j] = 0;
    else
      organ.fs->sin_values[j] = 1.0 / (j+1) / 3.1415926;
  }

  // Creo una nuova traccia stereo
  sa_track* track = sa_track_new(2);

  int beat = 6500;
  sample* ss;

  // Ci aggiungo un LA di un secondo
  ss = sa_silence(beat);
  sa_track_append (track, ss, beat, 0);
  sa_track_append (track, ss, beat, 1);
  for(j = 0; j< 3; j++ ) {
  ss = sa_note(organ, "A3", beat * 0.9);
  sa_track_append(track, ss, beat * 0.9, 0);
  sa_track_append(track, ss, beat * 0.9, 1);
  ss = sa_silence(0.1 * beat);
  sa_track_append(track, ss, beat * 0.1, 0);
  sa_track_append(track, ss, beat * 0.1, 1);
  }

  ss = sa_note(organ, "F3", beat * 7.5);  
  sa_track_append(track, ss, beat * 7.5, 0);
  sa_track_append(track, ss, beat * 7.5, 1);
  ss = sa_silence(0.5 * beat);
  sa_track_append(track, ss, beat * 0.5, 0);
  sa_track_append(track, ss, beat * 0.5, 1);

  ss = sa_silence(beat);
  sa_track_append (track, ss, beat, 0);
  sa_track_append (track, ss, beat, 1);


for(j = 0; j< 3; j++ ) {
  ss = sa_note(organ, "G3", beat * 0.9);
  sa_track_append(track, ss, beat * 0.9, 0);
  sa_track_append(track, ss, beat * 0.9, 1);
  ss = sa_silence(0.1 * beat);
  sa_track_append(track, ss, beat * 0.1, 0);
  sa_track_append(track, ss, beat * 0.1, 1);
  }

  ss = sa_note(organ, "E3", beat * 7.5);  
  sa_track_append(track, ss, beat * 7.5, 0);
  sa_track_append(track, ss, beat * 7.5, 1);
  ss = sa_silence(0.5 * beat);
  sa_track_append(track, ss, beat * 0.5, 0);
  sa_track_append(track, ss, beat * 0.5, 1);


  // E salviamo su file
  sa_track_write(track, "prova.cdr");

  sa_track_free(track);
  
  return 0;
}

